// prime48.c: Count prime numbers from 2 to 100
// works with both the SX48 and Microsoft Visual C, VC6....
// RW Senser
// 08/12/2007

#pragma chip SX48 // select device

// SX-KEY specific settings:
/*<?asm
	; DEVICE	turbo
	; DEVICE	optionx
	; DEVICE	stackx
	DEVICE	OSCHS3
	IRC_CAL	IRC_FAST
	FREQ	50_000_000
	RESET   main
?>*/

#define TRUE 1
#define FALSE 0
 
#ifdef _WIN32
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define bit int
#define uns16 unsigned int

#define page2
#define bank0
#define bank1
#define bank2
#define bank3
#define bank4
#define bank5
#define bank6
#define bank7

#else


// locate library routine in code page 2 instead of code page 1
page2 float24 operator* _fmul24( float24 arg1f24, float24 arg2f24);
page2 float24 operator/ _fdiv24( sharedM float24 arg1f24, sharedM float24 arg2f24);

// #pragma rambank 0
#include "sxio.h"


#pragma rambank 3
#pragma codepage 6
#include "math24f.h"

#pragma codepage 3
#include "ctype.h"
#include "stdlib.h"

#pragma codepage 0

#endif

bank6 char buffer[16];
bank7 unsigned int cnt;

static const char msg[30]  =  "prime running (2 to 100)\n\r";
static const char msg2[14] =  "\n\rprime cnt: ";
static const char msg3[15]  = "\n\rprime done\n\r";

#ifndef _WIN32
#pragma codepage 7
#pragma rambank 5
#endif

void dobreak() {
	/*<?asm
	break
	?>*/
	return;
}

bit prime(float f) {

	float f1;
	float f2;
	uns16 i;
	uns16 mid;
	uns16 asint;

	mid = f / 2.0;
	
	// dobreak();
	
	for (i = mid; i > 1; i--) {
		f2 = i;
		f1 = f / f2;
		asint = f1;
		f2 = asint;
		if (f1 == f2) return FALSE;
	}
	
return TRUE;

}
#ifndef _WIN32
#pragma rambank 3
#pragma codepage 0
#endif

#ifdef _WIN32
int main()
#else
void main(void)
#endif
{
	bit b;
	bank7 int j;
	bank7 int k;
	bank7 float try;
	
#ifndef _WIN32	
	
	clearRAM();  // built in function
	
	serial_on(100);		// turn on I/O
						// don't debug/step thru here as
						// interrupts are going ....
#endif						
	puts(msg);
	
	cnt = 0;

	for (j=2; j <= 100; j++) {
		try = j;
		b = prime(try);
		if (b == TRUE) {
			putchar('P');
			cnt++;
		} else {
			putchar('N');
		}
	}

	puts(msg2);
	// not working ??? itoa(cnt, buffer);
	// quick-fix kludge, good to 99, positive only
	k = cnt % 10;
	cnt = cnt / 10;
	j = cnt % 10;
	buffer[0] = '0' + j;
	buffer[1] = '0' + k;
	buffer[2] = 0x0;
	// enf of kludge
	puts(buffer);
	puts(msg3);
	
	dobreak();	// chance to stop and look at memory...
	            // buffer, with answer is in bank6

#ifndef _WIN32
	serial_off();
#endif	
}
